// nova-werun/pages/home/sport/sport-home/index.js
const Parse = getApp().Parse;
const company = getApp().globalData.company;
Page({

    /**
     * 页面的初始数据
     */
    data: {
        //屏幕高度
        statusBarHeight: 0, // 状态栏高度
        screenHeight: 0, // 屏幕高度
        customHeight: 0, // 自定义导航栏高度（如小程序右上角胶囊按钮）
        bottomNavHeight: 0, // 底部导航栏高度
        contentHeight: 0, // 可用内容高度
        contentHeight2: 0,
        contentpadding: 0, //顶部padding高度
        //
        currentTab: 0,
        //地图
        longitude: 0,
        latitude: 0,
        markers: [],
        //
        distance:0
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        // 计算
        const systemInfo = wx.getSystemInfoSync();
        const statusBarHeight = systemInfo.statusBarHeight || 0;
        const screenHeight = systemInfo.screenHeight || 0;
        const custom = wx.getMenuButtonBoundingClientRect();
        const customHeight = custom.height + 10 + 2 || 0;
        const bottomNavHeight = systemInfo.screenHeight - systemInfo.safeArea.bottom || 0;

        const contentpadding = (statusBarHeight + customHeight) * 750 / systemInfo.windowWidth;
        const contentHeight = (screenHeight - bottomNavHeight - statusBarHeight - customHeight) * 750 / systemInfo.windowWidth;
        this.setData({
            statusBarHeight,
            screenHeight,
            customHeight,
            bottomNavHeight,
            contentpadding,
            contentHeight,
        });
        if(Number(options.id)){
            this.setData({
                active:Number(options.id)
            })
        }
        //地图
        this.Getlocation()
        this.getwalk(0)
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    },
    //获取当前位置信息
    Getlocation() {
        // 获取当前位置信息
        wx.getLocation({
            type: 'gcj-02',
            success: (res) => {
                const {
                    latitude,
                    longitude
                } = res;
                console.log('获取到的经纬度:', latitude, longitude); // 添加日志
                //调用api解析地址
                wx.request({
                    url: 'https://api.map.baidu.com/reverse_geocoding/v3/?ak=sHZTomd7grslfP7sPKB8tRgT49FK9TEu&output=json&coordtype=gcj02&location=' + latitude + ',' + longitude,
                    data: {},
                    header: {
                        'Content-Type': 'application/json'
                    },
                    success: (ops) => { // 使用箭头函数
                        console.log(ops);
                        const address = ops.data.result.formatted_address;
                        this.setData({
                            address: address,
                            latitude: latitude, // 保证 latitude 被设置
                            longitude: longitude, // 保证 longitude 被设置
                            markers: [{ // 设置 markers
                                id: 1,
                                latitude: latitude,
                                longitude: longitude,
                                iconPath: 'https://file-cloud.fmode.cn/13WZ0W7u3l/20240724/7ebg0k104325941.png?imageView2/1/w/200/h/200', // 自定义标记图标
                                width: 40,
                                height: 40,
                                // callout: {
                                //     content: address, // 可以显示解析出的地址
                                //     color: '#ffffff',
                                //     bgColor: '#7F56B2',
                                //     padding: 10,
                                //     borderRadius: 5,
                                //     display: 'ALWAYS'
                                // }
                            }]
                        });
                        console.log(this.data.address);
                    },
                    fail: function (resq) {
                        wx.showModal({
                            title: '信息提示',
                            content: '请求失败',
                            showCancel: false,
                            confirmColor: '#f37938'
                        });
                    },
                    complete: function () {}
                })

            },
            fail: (err) => {
                console.error(err);
                wx.showToast({
                    title: '获取位置失败',
                    icon: 'none'
                });
            }
        });
    },
    //跳转
    gourl(e) {
        const url = e.currentTarget.dataset.url
        if(this.data.currentTab==0){
            const title='步行'
            wx.navigateTo({
                url: `${url}?id=`+title // 目标页面的路径
            });
        }else{
            const title='跑步'
            wx.navigateTo({
                url: `${url}?id=`+title // 目标页面的路径
            });
        }

    },
<<<<<<< HEAD
    haversineDistance(location1, location2) {
        let lat1 = location1.latitude
        let lon1 = location1.longitude
        let lat2 = location2.latitude
        let lon2 = location2.longitude
    
         function toRad(degree) {
             return degree * Math.PI / 180;
         }
         const R = 6371e3; // 地球半径，单位为米
         const φ1 = toRad(lat1);
         const φ2 = toRad(lat2);
         const Δφ = toRad(lat2 - lat1);
         const Δλ = toRad(lon2 - lon1);
     
         const a = Math.sin(Δφ / 2) * Math.sin(Δφ / 2) +
                   Math.cos(φ1) * Math.cos(φ2) *
                   Math.sin(Δλ / 2) * Math.sin(Δλ / 2);
         const c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
     
         const distance = R * c; // 距离，单位为米
         return distance;
     },
=======
    
    // 经纬度点距离 gcj-02坐标系
   haversineDistance(location1, location2) {
    let lat1 = location1.latitude
    let lon1 = location1.longitude
    let lat2 = location2.latitude
    let lon2 = location2.longitude

     function toRad(degree) {
         return degree * Math.PI / 180;
     }
     const R = 6371e3; // 地球半径，单位为米
     const φ1 = toRad(lat1);
     const φ2 = toRad(lat2);
     const Δφ = toRad(lat2 - lat1);
     const Δλ = toRad(lon2 - lon1);
 
     const a = Math.sin(Δφ / 2) * Math.sin(Δφ / 2) +
               Math.cos(φ1) * Math.cos(φ2) *
               Math.sin(Δλ / 2) * Math.sin(Δλ / 2);
     const c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
 
     const distance = R * c; // 距离，单位为米
     return distance;
 }
 
>>>>>>> c1abe100c0dbb4b7b2ded507c188ca0ff68f5825
    //切换
    switchTab (e) {
        const index = e.currentTarget.dataset.index;
        this.setData({
          currentTab: index
        });
        this.getwalk(index)
        console.log(this.data.currentTab);
      },
      //获取行走公里
     async getwalk(index){
        const currentUser = Parse.User.current();
        let ActivityDataquery = new Parse.Query('ActivityData');
        ActivityDataquery.equalTo('user', currentUser.id);
        ActivityDataquery.equalTo('company', company);
        if(index==0){
            ActivityDataquery.equalTo('type', 'walk');
        }else{
            ActivityDataquery.equalTo('type', 'run');
        }
        ActivityDataquery.notEqualTo('isDeleted', true);
        let r = await ActivityDataquery.find();
        let List = r.map(item => item.toJSON());
        let distance = 0
        List.forEach(item=>{
            distance =  Number(item.distance)+distance
        })
        this.setData({
            distance,
        })
        console.log('距离',this.data.distance);
      }
})